<?php
require_once('auth.php');
?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Konfigurationen bearbeiten - RRZE NavEditor 2.0 Beta</title>
<link rel="stylesheet" type="text/css" href="css/styles.css" />

<script type="text/javascript" src="js/jquery-1.2.6.pack.js"></script>
<script type="text/javascript" src="js/json2.js"></script>
<script type="text/javascript">
<!--
var loadFeedImportDone = false;
var feedCounter = 0;

var loadVorlagenDone = false;

var loadConfDone = false;

var loadConfListDone = false;

var currentConfFileName = "";

function loadConfList() {
	$.getJSON("app/edit_conf.php?r=" + Math.random(), {
		"oper": "get_conf_list",
		"conf_file_name": ""
	}, loadConfListCallback);
}

function loadConfListCallback(rdata) {
	// TODO
	cflHtml = "";
	for(var i = 0; i < rdata.length; i++) {
		cflHtml += "<li><a href='javascript:;' rel='" + rdata[i].file_name + "'>" + rdata[i].file_name + "</a></li>";
	}
	$("#confList ul").html(cflHtml);
	loadConfListDone = true;

	$("#confList a").click(function() {
		var cfn = $(this).attr("rel");
		switch(cfn) {
			case "feedimport.conf":
				showPanel("fld_feedimport");
				loadFeedImport();
				break;
//			case "univis.conf":
//				showPanel("fld_univis");
//				loadUnivIS();
//				break;
			case "vorlagen.conf":
				showPanel("fld_vorlagen");
				loadVorlagen();
				break;
			default:
				showPanel("fld_common");
				$("#fld_common legend").text(cfn);
				currentConfFileName = cfn;
				loadConf(cfn);
				break;
		}
	});
	
	// init. panel
	showPanel("fld_feedimport");
	loadFeedImport();
}

/* load normal conf-file */
function loadConf(confFileName) {
	$("#container").html("Loading...");
	$.getJSON("app/edit_conf.php?r=" + Math.random(), {
		"oper": "get_conf",
		"conf_file_name": confFileName
	}, loadConfCallback);
}

function loadConfCallback(rdata) {
	ciHtml = "";
	for(var i = 0; i < rdata.length; i++) {
		var ciName = rdata[i].opt_name;
		var ciNameLabel = "<p><label>" + ciName + "</label> ";
		var ciValue = "<input type='text' class='textBox' style='width:24em;' value='" + rdata[i].opt_value + "' /> ";
		ciHtml += (ciNameLabel + ciValue);
	}
	$("#container").html(ciHtml);
	loadConfDone = true;
}

/* vorlagen.conf related */
function loadVorlagen() {
	// vorlagen
	$.getJSON("app/edit_conf.php?r=" + Math.random(), {
		"oper": "get_vorlagen",
		"conf_file_name": "vorlagen.conf"
	}, loadVorlagenCallback); // load tree data
}

function loadVorlagenCallback(data) {
	var chkHtml = "";
	for(var i = 0; i < data.length; i++) {
		chkHtml += "<label for=\"chkvlgc" + i.toString() + "\">" + data[i].item + "</label> ";
		chkHtml += "<input type=\"checkbox\" id=\"chkvlgc" + i.toString() + "\"" + (data[i].value == 1 ? " checked=\"checked\"" : "") + " value=\"" + data[i].item + "\" />";
		chkHtml += "<br />";
	}
	$("#vorlagen").html(chkHtml);
	loadVorlagenDone = true;
}

function saveVorlagenCallback(data) {
	alert(data);
	location.reload();
}

function buildJSONVorlagen() {
	var arrJSON = [];
	var chks = $("#vorlagen :checkbox");
	for(var i = 0; i < chks.length; i++) {
		arrJSON.push(
			{
				"item": chks[i].value,
				"value": chks[i].checked == true ? 1 : 0
			}
		);
	}
	return JSON.stringify(arrJSON);
}

/* feedimport.conf related */
function loadFeedImport() {
	// feedimport
	$.getJSON("app/edit_conf.php?r=" + Math.random(), {
		"oper": "get_feedimport",
		"conf_file_name": "feedimport.conf"
	}, loadFeedImportCallback);	
}

function loadFeedImportCallback(rdata) {
	feedHtml = "";
	for(var i = 0; i < rdata.feeds.length; i++) {
		var feedId = rdata.feeds[i].id;
		var feedIdLabel = "<p><label>Feed-" + feedId + "</label> ";
		var feedTitle = "<input type='text' id='txtFeedTitle_" + feedId + "' class='textBox' size='32' value='" + rdata.feeds[i].title + "' /> ";
		var feedUrl = "<input type='text' id='txtFeedUrl_" + feedId + "' class='textBox' size='48' value='" + rdata.feeds[i].url + "' /> [<a href='javascript:;'>X</a>]</p>";
		feedHtml += (feedIdLabel + feedTitle + feedUrl);
		feedCounter++;
	}
	$("#feedimport").html(feedHtml + "<div class='mi'></div>");
	
	feedOptHtml = "";
	for(var j = 0; j < rdata.options.length; j++) {
		var feedOptName = rdata.options[j].opt_name;
		var feedOptNameLabel = "<p><label>" + feedOptName + "</label> ";
		var feedOptValue = "<input type='text' class='textBox' size='32' value='" + rdata.options[j].opt_value + "' /> ";
		feedOptHtml += (feedOptNameLabel + feedOptValue);
	}
	$("#feedimportOpts").html(feedOptHtml);
	
	// add event for removing
	$("#feedimport p a").click(function() {
		if(confirm("Sure to remove this item?")) {
			$(this).parent().remove();
		}
	});
	
	loadFeedImportDone = true;
}

function showPanel(panelId) {
	$("#contentPanel2 fieldset").hide(); // hide all
	$("#contentPanel2 #" + panelId).show();
}

/* ---------- Here comes jQuery: ---------- */
$(document).ready(function() {
	/* Vorlagen related */
	$("#btnUpdVorlagen").click(function() {
		if(!loadVorlagenDone) {
			return;
		}
		
		if(confirm("Are you sure to save?")) {
			$.post("app/edit_conf.php", {
				"oper": "set_vorlagen",
				"json_data": buildJSONVorlagen(),
				"conf_file_name": "vorlagen.conf"
			}, saveVorlagenCallback);
		}
	});
	/* /Vorlagen related */
	
	/* Feed-Import related */
	$("#btnAddFeedBox").click(function() {
		if(loadFeedImportDone) {
			feedCounter++;
			var newFeedBoxHtml = "<p><label>Feed-" + feedCounter + "</label> ";
			newFeedBoxHtml += "<input type='text' id='txtFeedTitle_" + feedCounter + "' class='textBox' size='32' /> ";
			newFeedBoxHtml += "<input type='text' id='txtFeedUrl_" + feedCounter + "' class='textBox' size='48' /> [<a href='javascript:;'>X</a>]</p>";
			$("#feedimport .mi").replaceWith(newFeedBoxHtml + "<div class='mi'></div>");
			
			// add event for removing
			$("#feedimport p a").click(function() {
				if(confirm("Sure to remove this item?")) {
					$(this).parent().remove();
				}
			});
		}
	});
	
	$("#btnAddItemFeedImport").click(function() {
		var genItemHtml = "";
//		genItemHtml += $("#feedimportGenItems").html();
		var newItemHtml = "<p><input type='text' name='txtGenItemFI_Name' class='textBox' style='width:7.75em;' />";
		newItemHtml += " <input type='text' name='txtGenItemFI_Val' class='textBox' style='width:9.75em' /> [<a href='javascript:;'>X</a>]</p>";
		$("#feedimportGenItems .mi").replaceWith(genItemHtml + newItemHtml + "<div class='mi'></div>");
		
		// for removing
		$("#feedimportGenItems p a").click(function() {
			if(confirm("Sure to remove?")) {
				$(this).parent().remove();
			}
		});
	});
	
	$("#btnUpdFeedImport").click(function() {
		if(!loadFeedImportDone) {
			return;
		}
		
		var postData = {
			"feeds": [],
			"options": [],
			"general_items": []
		};
		$("#feedimport p").each(function() {
			var feedIdStr = $(this).find("label").text();
			var feedId = feedIdStr.split("-")[1];
			var feedTitle = $(this).find("input").get(0).value;
			var feedUrl = $(this).find("input").get(1).value;
			var feedItem = {
				"id": feedId,
				"title": feedTitle,
				"url": feedUrl
			};
			postData.feeds.push(feedItem);
		});
		$("#feedimportOpts p").each(function() {
			var foName = $(this).find("label").text();
			var foValue = $(this).find("input").val();
			var foItem = {
				"opt_name": foName,
				"opt_value": foValue
			}
			postData.options.push(foItem);
		});
		$("#feedimportGenItems p").each(function() {
			var fgName = $(this).find("input[name=txtGenItemFI_Name]").val();
			var fgValue = $(this).find("input[name=txtGenItemFI_Val]").val();
			var fgItem = {
				"gi_name": fgName,
				"gi_value": fgValue
			};
			postData.general_items.push(fgItem);
		});
		if(confirm("Are you sure to update?")) {
			$(this).val("Moment...");
			$(this).attr("disabled", "disabled");
			$.post("app/edit_conf.php", {
				"oper": "set_feedimport",
				"conf_file_name": "feedimport.conf",
				"jsonData": JSON.stringify(postData)
			}, function(rdata) {
				alert(rdata);
				$("#btnUpdFeedImport").val("Update");
				$("#btnUpdFeedImport").removeAttr("disabled");
				location.reload();
			});
		}
	});
	
	/* common conf: post */
	$("#btnUpdConf").click(function() {
		if(!loadConfDone) {
			return;
		}
		var poData = [];
		$("#container p").each(function() {
			var ccName = $(this).find("label").text();
			var ccValue = $(this).find("input").val();
			var ccItem = {
				"opt_name": ccName,
				"opt_value": ccValue
			};
			poData.push(ccItem);
		});
//		alert(JSON.stringify(poData));
		if(confirm("Are you sure to update?")) {
			$(this).val("Moment...");
			$(this).attr("disabled", "disabled");
			$.post("app/edit_conf.php", {
				"oper": "set_conf",
				"conf_file_name": currentConfFileName,
				"jsonData": JSON.stringify(poData)
			}, function(rdata) {
				alert(rdata);
				$("#btnUpdConf").val("Update");
				$("#btnUpdConf").removeAttr("disabled");
				loadConf(currentConfFileName);
			});
		}
	});
	
	loadConfList();
	
});
// -->
</script>
</head>

<body id="bd_Conf">
<div id="wrapper">
	<h1 id="header">RRZE NavEditor 2.0 <sup>beta</sup></h1>
	<div id="navBar">
		<script type="text/javascript" src="js/page_nav.js"></script>
	</div>
	
	<div id="confList">
		<fieldset>
			<legend>Konfigurationsdatei</legend>
			<ul></ul>
		</fieldset>
	</div>
	
	<div id="contentPanel2">
		<form id="frmEdit">
			<fieldset id="fld_feedimport">
				<legend>feedimport.conf</legend>
				<div id="feedimport">Loading...<div class="mi"></div></div>
				<hr size="1" noshade="noshade" />
				<div id="feedimportOpts"></div>
				<div id="feedimportGenItems"><div class="mi"></div></div>
				<hr size="1" noshade="noshade" />
				<input type="button" id="btnAddFeedBox" value="Add Feed" class="button" />
				<input type="button" id="btnAddItemFeedImport" value="Add General Config-Item" class="button" />
				<input type="button" id="btnUpdFeedImport" value="Update" class="button" />
			</fieldset>
			
			<fieldset id="fld_common">
				<legend></legend>
				<div id="container">Loading...</div>
				<hr size="1" noshade="noshade" />
				<input type="button" id="btnUpdConf" value="Update" class="button" />
			</fieldset>
			
			<fieldset id="fld_vorlagen">
				<legend>vorlagen.conf</legend>
				<div id="vorlagen">Loading...</div>
				<hr size="1" noshade="noshade" />
				<input type="button" id="btnUpdVorlagen" value="Update" class="button" />
			</fieldset>
		</form>
	</div>
	
	<div id="footer">&copy; 2007-08 Ke.Chang@rrze.uni-erlangen.de</div>
</div>
</body>

</html>
